<template>
  <div>
    <v-navigation-drawer v-model="drawer" app color="grey darken-3">
      <v-divider></v-divider>

      <v-list nav>
        <v-list-item
          v-for="([icon, pageName, route], i) in links"
          :key="i"
          @click="goTo(route)"
          class="d-flex align-baseline"
        >
          <v-list-item-icon>
            <v-icon v-text="icon" class="white--text"></v-icon>
          </v-list-item-icon>

          <v-list-item-content class="white--text">
            <v-list-item-title v-text="pageName"></v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </v-navigation-drawer>

    <v-app-bar app flat color="primary" class="white--text">
      <v-app-bar-nav-icon
        @click="drawer = !drawer"
        color="white"
      ></v-app-bar-nav-icon>

      <v-toolbar-title>{{ page }}</v-toolbar-title>

      <v-spacer></v-spacer>

      <v-menu left bottom>
        <template v-slot:activator="{ on, attrs }">
          <v-btn class="white--text" icon v-bind="attrs" v-on="on">
            <v-icon>mdi-account</v-icon>
          </v-btn>
        </template>

        <v-list>
          <v-list-item @click="logout">
            <v-list-item-title>Logout</v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </v-app-bar>

    <v-main>
      <v-container>
        <router-view />
      </v-container>
    </v-main>
  </div>
</template>

<script>
export default {
  name: "Main",
  data: () => ({
    drawer: false,
    page: "Home",
    links: [
      ["mdi-home", "Home", "/home"],
      ["mdi-account", "Alunos", "/students"],
      ["mdi-school", "Instrutores", "/instructors"],
    ],
  }),
  beforeMount() {
    this.page = this.$route.name;
  },
  updated() {
    this.page = this.$route.name;
  },
  methods: {
    goTo(route) {
      if (this.$route.path !== route) {
        this.$router.push(route);
      }
    },

    logout() {
      this.$store.dispatch("user/logout");
      this.$router.push("/");
    },
  },
};
</script>
